/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ui.view.components;

import domain.Invoice;
import domain.InvoiceItem;
import domain.Product;
import java.math.BigDecimal;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelInvoiceItems extends AbstractTableModel{
    private Invoice invoice;
    private String[] columnNames=new String[]{"RB", "Proizvod", "Jedinica mere", "Cena", "Količina", "Iznos"};

    public TableModelInvoiceItems(Invoice invoice) {
        this.invoice=invoice;
    }

    @Override
    public String getColumnName(int i) {
        return columnNames[i];
    }
    
    
    
    @Override
    public int getRowCount() {
        return invoice.getInvoiceItems().size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public Object getValueAt(int x, int y) {
        InvoiceItem item=invoice.getInvoiceItems().get(x);
        switch(y){
            case 0:
                return item.getItermNumber();
            case 1:
                return item.getProduct().getName();
            case 2:
                return item.getProduct().getMeasurementUnit();
            case 3:
                return item.getPrice();
            case 4: 
                return item.getQuantity();
            case 5:
                return item.getPrice().multiply(new BigDecimal(item.getQuantity()));
            default:
                return "n/a";
        }
    }
    
    public void addInvoiceItem(Product product, Long quantity){
        InvoiceItem item=new InvoiceItem();
        item.setItermNumber(new Long(invoice.getInvoiceItems().size()+1));
        item.setProduct(product);
        item.setPrice(product.getPrice());
        item.setQuantity(quantity);
        invoice.getInvoiceItems().add(item);
        fireTableDataChanged();
    }
    
    public void removeInvoiceItem(int rowIndex){
        invoice.getInvoiceItems().remove(rowIndex);
        setItemNumbers();
        fireTableDataChanged();
    }
    
    private void setItemNumbers(){
        long no=0;
        for(InvoiceItem item:invoice.getInvoiceItems()){
            item.setItermNumber(++no);
        }
    }
    
    public Invoice getInvoice(){
        return invoice;
    }
    
}
